# -*- coding: utf-8 -*-
# actor.py
# author: Gerd Doeben-Henisch
# Collection of functions to support simple actors

PID="ACC:\n "
        
class ACTOBJ:
    """This is a first sketch for an actor class. It has to be developed further """
    
    type = 'actor'
    inpMsg =''      #Message from the environment
    OutMsg = ''     #Message to the environment
    intake = 0      #Energy Offer with food
    behavefct = 1   #Type of behavior function {1,2}
    behavefctMax = 2 #Actual upper limit
    energy = 250
    energyrate = 5
    
    
    def __init__(self,name,time,x,y,DIR,color, energy,energyrate):
        self.name = name
        self.time = time
        self.position = (x,y)
        self.dir = DIR
        self.color = color
        self.energy = energy
        self.energyrate = energyrate
        
    def getName(self):
        return self.name
    
    def setName(self,name):
        #This should be a short name different from others; a number 
        # is enough ...         
        self.name = name
        
    def getTime(self):
        return self.time
    
    def setTime(self,time):
        #The time will be derived  from the environment time
         self.time = time

    def getPos(self):
        # This is the position in the data array with simple (x,y) coordinates
        return self.position

    def setPos(self,x,y):
        # This is the position in the data array with simple (x,y) coordinates
        # The array counts from 0 ... n-1
        # The user counts from 1 ... n
         self.position = (x,y)
    
    def setDir(self,DIR):
        # There are four basic directions as {1,2,3,4}
        self.dir = DIR
        
    def getDir(self):
        # There are four basic directions as {1,2,3,4}
        return self.dir 
         
    def getColor(self):
        # All actors have the color red (for now; perhaps more later)
        return self.color
    
    
    def setColor(self,incolor):
         # All actors have the color red (for now; perhaps more later)
         self.color = incolor
    
    def setEnergy(self,energy):
        # Show actual energy level
        self.energy = energy
    
    def getEnergy(self):
        # Show actual energy level
        return self.energy
    
    def setEnergyRate(self,energyrate):
        # Show actual energy level
        self.energyrate = energyrate
    
    def getEnergyRate(self):
        # Show actual energy level
        return self.energyrate    

    def setOutputMessage(self,outputMessage):
        #Some message to the environment
        self.OutMsg=outputMessage
        
    def getOutputMessage(self):
        return  self.OutMsg
    
    def setInputMessage(self,inputMessage):
        #Some message to the environment
        self.inpMsg=inputMessage
        
    def getInputMessage(self):
        return  self.inpMsg
    
    def setIntake(self,intake):
        #Some message from the environment to the actor
        self.intake=intake
        
    def getIntake(self):
        return  self.intake  
    
    def setBehavior(self,behavior):
        #Number 0 ore higher
        #Some message from the environment to the actor
        self.behavefct=behavior
        
    def getBehavior(self):
        return  self.behavefct 
    

    

def behaviorActFix(e,a):
    
    '''
    This defines the behavior which is 'fixed', that means that the actor will always change        
    his direction in a definite manner. In this case here we have a 'right-handed' actor who    
    changes his direction only, if he hits an obstacle, and then he is turining 90 degree to 
    the 'right' 
    
    COMPUTE A DIRECTION, IF NECESSARY
    '''
    
    import numpy as np
    import environment as env
    import acctor as acc
    import math
    
    name = a.getName()
    
    #BODY PART
    #INTAKTE OF FOOD IF AVAILABLE
    
    f = a.getIntake()
    if f > 0:
        eold = a.getEnergy()
        enew = eold + f
        a.setEnergy(enew)
        a.setIntake(0)      #Set value back to zero
        print(PID+'Actor ',name,' has  increased ENERGYLEVEL = ',enew)
        
    # The energy decreases regularily every cycle
        
    erate = a.getEnergyRate()
    ener = a.getEnergy()
    
    energynew = ener - erate
    a.setEnergy(energynew)
    
    print(PID+'Actor ',name,' has new energy level = ',energynew)
    
    #MENTAL PART
    #Determining the new direction
    
    #Checking for feedback. If 'NoMove' then change direction
    
    f = a.getInputMessage()
    print(PID+'Input Message from ENV  ',f)
    
    if f == "NoMove":
        print(PID+'Identification of -NoMove- happened')
        dirold = a.getDir()
        dirnew = dirold + 1
        if dirnew > 4:
            dirnew = dirnew % 4
            print(PID+'dirold, dirnew if >4 ',dirold, dirnew)
        a.setDir(dirnew)
        print(PID+'New direction of actor ',name, ' is = ',dirnew)
    
    a.setOutputMessage('yesMove')
    print(PID+'actor ',name, 'wants to move')
    
    
        
 
    
def behaviorAcRand(e,a):
    
    import numpy as np
    import environment as env
    import acctor as acc
    
    #BODY PART
    # Compute time since last call and change energy level
    
    name = a.getName()
    
    #check for food-intake
    
    f = a.getIntake()
    if f > 0:
        eold = a.getEnergy()
        enew = eold + f
        a.setEnergy(enew)
        a.setIntake(0)      #Set value back to zero
        print(PID+'Actor ',name,' has  increased ENERGYLEVEL = ',enew)
    
        
    # The energy decreases regularily every cycle
        
    erate = a.getEnergyRate()
    ener = a.getEnergy()
    
    energynew = ener - erate
    a.setEnergy(energynew)
    
    print(PID+'Actor ',name,' has new energy level = ',energynew)
    
    #MENTAL PART
    # Determine the new direction
    
    dirspace = 4
    dirnew = np.random.randint(1,dirspace+1)
    a.setDir(dirnew)
    print(PID+'New direction of actor ',name, ' is = ',dirnew)
    
    a.setOutputMessage('yesMove')
    print(PID+'actor ',name, 'wants to move')
    
    return dirnew
    
    
def introduceActor(engine,win,distance,gr2,time):
       import acctor as acc           #Acctor related functions
       import environment as env      #Functions to generate grids   
       
       engine.say('Hallo User, ')
       engine.say('Klicke in das Gitter, wo Du den Akteur plazieren willst..')
       engine.runAndWait()
       
      # Get coordinate of the mouse-click as starting point
       p = win.getMouse()
       p.draw(win)
       xc=p.getX()
       yc=p.getY()
       print(PID+'Point mouse click actor ',p,xc,yc)
       
       #Transform the window coordinates into the array coordinates
       xs = int(xc/distance)
       ys = int(yc/distance) 
       x = xs+1
       y=ys+1
       print(PID+'Center Array  ',(x,y))
       
       #Insert the actor in the data array
       gr2[xs,ys]=3
       
       #Introduce more parameter for new actor object
       dir=1
       color = 'red'
       name="A1"
       energy=2000
       energyrate=2
       
       #Generate an instance of the actor class ACTOBJ
       a1=acc.ACTOBJ(name,time,x,y,dir,color, energy,energyrate)
       a1.setName(name)
      
       a1.setPos(x,y)  #Write actual position of actor into actor object
       outputMessage='yesMove'  #This tells the environment whether an actor
                           #wants to move
       a1.setOutputMessage(outputMessage)
      
       #Realize an actor on the window
       env.introduceActorEye(x,y,dir,name,color,energy,distance,win)
      
       print(PID+'MAP OF ARRAY \n')
       print(PID+str(gr2))
       print(PID+'ATTENTION: Columns represent Rows on screen!\n')
       
       return a1

## The auto version allows the automatic (random) generation of the start position
     
def introduceActorAuto(engine,LNGFLAG,win,distance,gr2,time,first,last,autoStart,SLEEP,GridSizeN):
    
       import acctor as acc           #Acctor related functions
       import environment as env      #Functions to generate grids  
       import numpy as np
       
       if autoStart < 1:
           if LNGFLAG == 'de':
               engine.say('Hallo User, ')
               engine.say('Klicke in das Gitter, wo Du den Akteur plazieren willst..')
               engine.runAndWait()
           else:
               engine.say('Hallo User, ')
               engine.say('Click into the grid where you want to place the actor')
               engine.runAndWait()
       
           # Get coordinate of the mouse-click as starting point
           p = win.getMouse()
           p.draw(win)
           xc=p.getX()
           yc=p.getY()
           print(PID+'Point mouse click actor ',p,xc,yc)
       
           #Transform the window coordinates into the array coordinates
           x = int(xc/distance)
           y = int(yc/distance) 

           print(PID+'Position of Actor by Click ',(x+1,y+1))
           
           #Insert the actor in the data array
           gr2[y,x]=3
           
       else: ## Generate coordinates randomly
           SEARCH = 1
           while SEARCH == 1:
               p=np.random.randint(first,last+1,size=2) #coordinates for the fillgridobj
               print(PID+'Random Auto-Point ',p)
               
               x=p[0]-1 ## Get the x-coordinate and decrement by 1 for the Grid
               y=p[1]-1 ## Get the y-coordinate and decrement by 1 for the Grid
        
               print(PID+'Normalized Point',(x,y))
                         
               if gr2[y,x] == 0:  
                  gr2[y,x]=3 ## Locate Actor in Grid
                  SEARCH = 0
       
       #Introduce more parameter for new actor object
       dir=1
       color = 'red'
       name="A1"
       energy=250
       energyrate=5
       
       #Generate an instance of the actor class ACTOBJ
       a1=acc.ACTOBJ(name,time,x+1,y+1,dir,color, energy,energyrate)
       a1.setName(name)

       outputMessage='yesMove'  #This tells the environment whether an actor
                           #wants to move
       a1.setOutputMessage(outputMessage)
      
       #Realize an actor on the window
       env.introduceActorEye(x,y,dir,name,color,energy,distance,win)
      
       print(PID+'MAP OF ARRAY \n')
       print(PID,gr2)
 
       
       return a1