# -*- coding: utf-8 -*-
# environment.py
# author: Gerd Doeben-Henisch
# Collection of functions to support simple enviroments
# Using book from John Zelle (2002) and his simple graphics.py library

PID="ENV:\n "

class ENVOBJ:
    """This is a first sketch for an environment class. It has to be developed further """
    
    def __init__(self,envname,envclock,objtPerc,foodPerc,foodEnergy):
    
        self.name = envname
        self.clock = envclock
        self.objPerc = objtPerc
        self.foodPerc = foodPerc
        self.foodEnergy = foodEnergy 
    
    def getName(self):
        return self.envname
    
    def setName(self,envname):
         self.name = envname
         
    def getClock(self):
        return self.clock
    
    def setClock(self,envclock):
         self.clock = envclock

    def getObjPerc(self):
        return self.objtPerc
    
    def setObjPerc(self,objtPerc):
         self.objtPerc = objtPerc         

    def getFoodPerc(self):
        return self.foodPerc
    
    def setFoodPerc(self,foodPerc):
         self.foodPerc = foodPerc         

    def getFoodEnergy(self):
        return self.foodEnergy
    
    def setFoodEnergy(self,foodEnergy):
         self.foodEnergy = foodEnergy
         
def grid(win,xmax,ymax,first,last,distance):
    
   import graphics as grph
   import numpy as np
   
   lx=list(range(first,last+1))
   linex = grph.Line(grph.Point(0,0), grph.Point(0,ymax-1))
     
   for i in range(first,last):     
       lx[i]=linex.clone()
       lx[i].move(i*distance,0)
       lx[i].draw(win)
       
   ly=list(range(first,last+1))    
   liney = grph.Line(grph.Point(0,0), grph.Point(xmax-1,0))
   
   for i in range(first,last):     
       ly[i]=liney.clone()
       ly[i].move(0,i*distance)
       ly[i].draw(win)
  

         
def fillgridobj(win,first, last, xmax,ymax):
    import graphics as grph
    import numpy as np
    
    # Generate a matrix with a random distribution of '0' and '1'.
    gr2=np.random.randint(2, size=(last,last))
    
    print(PID+'MAP OF ARRAY \n')
    print(PID,gr2)

    
    for y in range(0,7):
        for x in range(0,7):
            if gr2[x,y] == 1:
               print(PID+x+1,y+1)
               rect1 = grph.Rectangle(grph.Point(x*100,y*100), grph.Point((x+1)*100,(y+1)*100)) 
               rect1.setFill('black')
               rect1.draw(win)
              
    return gr2

def fillgridobj2(win,distance,first, dimensionX, maxXcoord,maxYcoord,nobj):
 
    #nobj gives the percentage how many  objects shall be inserted into the matrix
    
    import graphics as grph
    import numpy as np
    
    #Compute number of wanted objects by percentage
    
    number=int(((maxXcoord*maxYcoord)/distance)*nobj)
    if number <1:  
        number=1
         
    ## Generate a grid-datastructure as an array
    gr2=np.zeros((maxXcoord,maxYcoord),int)
    
    # To fill this grid with obstacle-objects 
    # Produce randomly the coordinates for these
    
    for i in range(1,number):
        p=np.random.randint(first,dimensionX+1,size=2) #coordinates for the fillgridobj
        print(PID+'Random Point ',p)
        
        x=p[0]-1 ## Get the x-coordinate and decrement by 1 for the Grid
        y=p[1]-1 ## Get the y-coordinate and decrement by 1 for the Grid
        
        print(PID+'Normalized Point',(x,y))
        
        gr2[x,y]=1    # Set a marker in the data array
        
        print(PID+'Inserted in Grid',gr2)

        
        #translating the fillgridob coordinates into the graphics coordinates 
        
        rect1 = grph.Rectangle(grph.Point(y*distance,x*distance), grph.Point((y+1)*distance,(x+1)*distance)) 
        rect1.setFill('black')
        rect1.draw(win)
        
    print(PID+'MAP OF ARRAY \n')
    print(PID,gr2)

        
    return gr2        


               
def fillgridfood(win,distance,first,last, maxXcoord,maxYcoord,nfood,gr2):
    
    #n gives the numer of food inserted into the matrix
    
    import graphics as grph
    import numpy as np
    
    number=int(((maxXcoord*maxYcoord)/distance)*nfood)
    if number <1:  
        number=1


    for i in range(1,number+1):
        p=np.random.randint(first,last+1,size=2) #coordinates for the fillgridobj
        print(PID+'Random Point ',p)
        
        x=p[0]-1 ## Get the x-coordinate and decrement by 1 for the Grid
        y=p[1]-1 ## Get the y-coordinate and decrement by 1 for the Grid
        
        print(PID+'Normalized Point',(x,y))
        
        gr2[x,y]=2    # Set a marker in the data array
        
        print(PID+'Inserted in Grid',gr2)
        
        #translating the fillgridob coordinates into the graphics coordinates
        rect1 = grph.Rectangle( grph.Point(y*distance,x*distance ),grph.Point( (y+1)*distance,(x+1)*distance) )
        rect1.setFill('green')
        rect1.draw(win)
        
    print(PID+'OBSTACLES with FOOD \n')
    
    # This conversion shows a matrix whose columns correspond to the
    # rows of the original matrix !

    
    print(PID+'MAP OF ARRAY \n')
    print(PID,gr2)

    return gr2

def gprint(a,lasty):
    
    #This conversion shows rows after the conversion which correspnd
    #to the columns in the original array !
    
    import numpy as np
    
    s=""
    for i in range(0,a.size):
        s=s+str(a.item(i))
        
    print(PID+s)
        
    for j in range(0,lasty):
        print(PID+'\n ', s[(j*lasty):(j*lasty)+7])
        

    #Introduce an actor on a certain position in the window
    
def introduceActor(x,y,dir,name,color,energy,distance,win):
    
    PID="introduceActor:\n "
    
    # Convert array coordinates (x,y) into window coordinates (xwin,ywin)
    import numpy as np
    import graphics as grph
        
    rect1 = grph.Rectangle(grph.Point((x-1)*distance,(y-1)*distance), grph.Point((x)*distance,(y)*distance)) 
    rect1.setFill('HoneyDew')
    rect1.draw(win)
    
    #insert actor
    xwin = ((x-1)*distance)+(distance/2)
    ywin = ((y-1)*distance)+(distance/2)
    
    #gnerate a red circle
    center = grph.Point(xwin,ywin)
    circ = grph.Circle(center, distance/2)
    circ.setFill(color)
    circ.draw(win)
    
    #gnerate a name as a lable 
    label = grph.Text(center, name)
    label.draw(win)
    
## Introduce actor with an eye in direction 1
def introduceActorEye(x,y,dir,name,color,energy,distance,win):
    
    PID="introduceActorEye:\n "
    
    # Convert array coordinates (x,y) into window coordinates (xwin,ywin)
    import numpy as np
    import graphics as grph
        
    rect1 = grph.Rectangle(grph.Point((x)*distance,(y)*distance), grph.Point((x+1)*distance,(y+1)*distance)) 
    rect1.setFill('HoneyDew')
    rect1.draw(win)
    
    #insert actor
    xwin = ((x)*distance)+(distance/2)
    ywin = ((y)*distance)+(distance/2)
    
    #gnerate a red circle
    center = grph.Point(xwin,ywin)
    circ = grph.Circle(center, distance/2)
    circ.setFill(color)
    circ.draw(win)
    
    '''
    Do not use it now
    #gnerate a name as a lable 
    label = grph.Text(center, name)
    label.draw(win)
    '''
    
    #introduce a black eye
    xeye = ((x)*distance)+(distance/2)
    yeye = ((y)*distance)+(distance/4)
    
    #generate a black eye
    center = grph.Point(xeye,yeye)
    circ = grph.Circle(center, distance/4)
    circ.setFill('black')
    circ.draw(win)        
    
    
    
#Introduce an actor on a certain position in the window
    
def introduceActor2(a, x,y,distance,win):
    
    PID="introduceActor2:\n "
    
    # Convert array coordinates (x,y) into window coordinates (xwin,ywin)
    import numpy as np
    import graphics as grph
        
    rect1 = grph.Rectangle(grph.Point((x-1)*distance,(y-1)*distance), grph.Point((x)*distance,(y)*distance)) 
    rect1.setFill('HoneyDew')
    rect1.draw(win)
    
    #insert act or
    xwin = ((x-1)*distance)+(distance/2)
    ywin = ((y-1)*distance)+(distance/2)
    
    #gnerate a red circle
    color = a.getColor()
    center = grph.Point(xwin,ywin)
    circ = grph.Circle(center, distance/2)
    circ.setFill(color)
    circ.draw(win)
    
    #gnerate a name as a lable 
    name = a.getName()
    label = grph.Text(center, name)
    label.draw(win)
    
    
    
def introduceActor2Eye1(a,distance,win,DIR):
    
    PID="introduceActor2Eye1:\n "
    
    # Convert array coordinates (x,y) into window coordinates (xwin,ywin)
    import numpy as np
    import graphics as grph
    
    p=a.getPos()
    
    x=p[0]-1
    y=p[1]-1

        
    rect1 = grph.Rectangle(grph.Point(x*distance,y*distance), grph.Point((x+1)*distance,(y+1)*distance)) 
    rect1.setFill('HoneyDew')
    rect1.draw(win)
    
    #insert actor
    xwin = ((x)*distance)+(distance/2)
    ywin = ((y)*distance)+(distance/2)
    
    #gnerate a red circle
    color = a.getColor()
    center = grph.Point(xwin,ywin)
    circ = grph.Circle(center, distance/2)
    circ.setFill(color)
    circ.draw(win)
    
    '''
    Do not use it now
    #gnerate a name as a lable 
    name = a.getName()
    label = grph.Text(center, name)
    label.draw(win)
    '''
    
    #introduce a black eye
    
    if DIR == 1:
        xeye = ((x)*distance)+(distance/2)
        yeye = ((y)*distance)+(distance/4)
    elif DIR == 2:
        xeye = ((x)*distance)+(distance*0.75)
        yeye = ((y)*distance)+(distance/2)
    elif DIR == 3:
        xeye = ((x)*distance)+(distance*0.5)
        yeye = ((y)*distance)+(distance*0.75)   
    else:
        xeye = ((x)*distance)+(distance*0.25)
        yeye = ((y)*distance)+(distance*0.5) 
        
    #generate a black eye
    center = grph.Point(xeye,yeye)
    circ = grph.Circle(center, distance/4)
    circ.setFill('black')
    circ.draw(win)  
    
    
#Introduce an actor on a certain position in the window
    
def introduceActor2Eye(a,xnew,ynew, distance,win,DIR):
    
    PID="introduceActor2Eye:\n "
    
    # Convert array coordinates (x,y) into window coordinates (xwin,ywin)
    import numpy as np
    import graphics as grph
 
    x=xnew-1
    y=ynew-1

        
    rect1 = grph.Rectangle(grph.Point(x*distance,y*distance), grph.Point((x+1)*distance,(y+1)*distance)) 
    rect1.setFill('HoneyDew')
    rect1.draw(win)
    
    #insert actor
    xwin = ((x)*distance)+(distance/2)
    ywin = ((y)*distance)+(distance/2)
    
    #gnerate a red circle
    color = a.getColor()
    center = grph.Point(xwin,ywin)
    circ = grph.Circle(center, distance/2)
    circ.setFill(color)
    circ.draw(win)
    
    '''
    Do not use it now
    #gnerate a name as a lable 
    name = a.getName()
    label = grph.Text(center, name)
    label.draw(win)
    '''
    
    #introduce a black eye
    
    if DIR == 1:
        xeye = ((x)*distance)+(distance/2)
        yeye = ((y)*distance)+(distance/4)
    elif DIR == 2:
        xeye = ((x)*distance)+(distance*0.75)
        yeye = ((y)*distance)+(distance/2)
    elif DIR == 3:
        xeye = ((x)*distance)+(distance*0.5)
        yeye = ((y)*distance)+(distance*0.75)   
    else:
        xeye = ((x)*distance)+(distance*0.25)
        yeye = ((y)*distance)+(distance*0.5) 
        
    #generate a black eye
    center = grph.Point(xeye,yeye)
    circ = grph.Circle(center, distance/4)
    circ.setFill('black')
    circ.draw(win)  
    
    ## Tell actor the new position
    a.setPos(xnew,ynew)
    
    ## Tell the message to move
    a.setInputMessage('YesMove')
    print(PID+'actor has moved')

    
def deleteActor1(a,win,distance,gr):
    
    PID="deleteActor1:\n "
    ## Delete only the appearance of an actor

    # Convert array coordinates (x,y) into window coordinates (xwin,ywin)
    import numpy as np
    import graphics as grph
    
    
    p=a.getPos()
    
    print(PID+'deleteActor1 getPos : ',p)
    print(PID+'Grid Before Deletion: ',gr)   
    x=p[0]-1
    y=p[1]-1
    
    print(PID+'Grid After Deletion of Appearance: ',gr)
        
    #translating the fillgridob coordinates into the graphics coordinates 
        
    rect1 = grph.Rectangle(grph.Point(x*distance,y*distance), grph.Point((x+1)*distance,(y+1)*distance)) 
    rect1.setFill('HoneyDew')
    rect1.draw(win)
    
    
def deleteActor2(a,win,distance,gr):

    PID="deleteActor2:\n "
    
    #Delete the appearance of an actor on a certain position in the window
    # as well its Grid-avatar
    
    # Convert array coordinates (x,y) into window coordinates (xwin,ywin)
    import numpy as np
    import graphics as grph
    
    
    p=a.getPos()
    
    print(PID+'deleteActor2 getPos : ',p)
    print(PID+'Grid Before Deletion: ',gr)   
    x=p[0]-1
    y=p[1]-1
    gr[y,x]=0 ## Replace old position of actor with 0
    
    print(PID+'Grid After Deletion: ',gr)
        
    #translating the fillgridob coordinates into the graphics coordinates 
        
    rect1 = grph.Rectangle(grph.Point(x*distance,y*distance), grph.Point((x+1)*distance,(y+1)*distance)) 
    rect1.setFill('HoneyDew')
    rect1.draw(win)
    
    

    
def moveArray(TYPEID,a,xnew,ynew,gr):
    
    PID="moveArray:\n "
    
    #Move to new position in data array
    
    import numpy as np
    
    p=a.getPos() 
    xold=p[0]
    yold=p[1]
    
    print(PID+'Grid Before Deletion: ',gr)  
    
    gr[yold-1,xold-1]=0 ## Replace old position of actor with 0
    
    print(PID+'Grid After Deletion: ',gr)
    
    gr[ynew-1,xnew-1]=TYPEID
    
    print(PID+'Grid After Deletion and NEW insertion: ',gr)

    
    
# Compute a new position starting with an old position and a direction
    
def newPosition(a,dimensionX):
    
    PID="newPosition:\n "
    
    dimensionY = dimensionX
    
    newdir = a.getDir()
    p=a.getPos()
    
    print(PID+'p=getPos : ',p)
  
    xold=p[0]
    yold=p[1]
    
    print(PID+'Inside Newposition - newdir,xold,yold ',newdir,xold,yold)

    Err=0
    xnew = xold
    ynew = yold
    
    if newdir == 1: ### moving upwards
        
        print(PID+'newdir 1')
        if yold - 1<1:
            ynew = yold
        else:
            ynew=yold-1
    elif newdir == 2:  ## moving to the right
        print(PID+'newdir 2')
        if xold+1 > dimensionX:
            xnew = xold
        else:
            xnew=xold+1
    elif newdir == 3: ##moving downwards
        print(PID+'newdir 3')
        if yold+1 >dimensionY:
            ynew = yold
        else:
            ynew=yold+1
    elif newdir == 4: ## moving to the left
        print(PID+'newdir 4')
        if xold-1 < 1:
            xnew = xold
        else:
            xnew=xold-1
    else:
        print(PID+'ERROR : Wrong newdirection ! ')
        Err=-1
     
    print(PID+'Inside Newposition - newdir,xnew,ynew ',newdir,xnew,ynew)
 
    
    return Err, xnew, ynew
        
###################################################################   
## FILL IN TONES IN A SQUARE
###############################################################

'''
There is a window with coordinates lower left  (0,0), upper right (n,n)
bb gives you the number of bars (= number of rows)
bts gives you the number of bets per bar (= number of columns)
algoo gives you the object containing the algorithm with the population of tones
'''


def writeTones(win,bb,bts,algoo):
    
    import graphics as grph
    
    P = algoo.getPop()
    
    # Searching in P
    for i in range(0,(bb*bts)-1):
        
        #Placing in Y-Dimension (rows)
        for y in range(0,bb-1):
            
            #Placing in X-Dimension
            for x in range(0,bts-1):
                
                #Writing a tone
                txtbars = grph.Text(grph.Point(x,y), P[i]).draw(win)
                txtbars.setTextColor('black')
                
    algoo.setPop(P)
    
    #test
    print(PID+'P new = ',P)
    
#################################################################
## Plot the results of experiment
#################################################################
## SUMMARIZE
## (1) ENERGY
## (2) % OBSTACLES
## (3) % FOOD
#######################################################
    
def my_plotter(ENERGYAR, EMAX,REPEAT,OBST,FOOD):
    ## Print Identifier
    PID='myPlot: \n'
    
    import numpy as np
    import matplotlib.pyplot as plt

    
    x = np.arange(1,REPEAT+1,1)
    
    print(PID+'x ',x)
    
    y1 = ENERGYAR
    
    print(PID+' y1 ',y1)
    
    plt.plot(x, y1, label='ENERGY %')

    plt.xlabel('x Number of Experiments')
    plt.ylabel('y %Energy '+str(EMAX)+' %Obst '+str(OBST)+' %Food '+str(FOOD) )

    plt.title("SUMMARY OF EXPERIMENTS")

    plt.legend()

    plt.show()
    
def my_plotterMean(ENERGYAR, EMAX,REPEAT,OBST,FOOD,BEHAVETYPE):
    ## Print Identifier
    PID='myPlotMean: \n'
    
    import numpy as np
    import statistics as stats
    import matplotlib.pyplot as plt

    
    ## Baseline
    x = np.arange(1,REPEAT+1,1)
    print(PID+'x ',x)
    
    ## The energyvalues in percentage of EAX
    y1 = ENERGYAR
    
    ## The mean of all energy-values
    meanY1 = stats.mean(y1)
    print(PID+' y1,',y1,'Mean : ', meanY1)
    
    ## Generate an array of means
    l=len(y1)
    y2 = np.zeros(len(y1),int)

    for i in range(0,len(y1),1):
        y2[i] = meanY1
        
    ## Compute death-rate DR
    DR = 0
    for i in range(0,len(y1),1): 
        if y1[i] < 1:
            DR += 1
        
    DRPERC = int(DR/(len(y1)/100))
    print(PID+'Death-Rate DR in % :',DRPERC)
        
    ## Plot the energy-values against the mean
    plt.plot(x, y1, label='ENERGY %')
    plt.plot(x,y2, label = 'MEAN')

    plt.xlabel('x Number of Experiments'+' BTYPE : '+str(BEHAVETYPE)+' DR% : '+str(DRPERC))
    plt.ylabel('y %Energy '+str(EMAX)+' %Obst '+str(OBST)+' %Food '+str(FOOD) )

    plt.title("SUMMARY OF EXPERIMENTS")

    plt.legend()

    plt.show()
            
            
            
        
        
        
               
               
               
    
         
         
         
        
        






